"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _vueTypes = _interopRequireDefault(require("../../_util/vue-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultProps = {
  accessibility: _vueTypes.default.bool.def(true),
  // 自定义高度
  adaptiveHeight: _vueTypes.default.bool.def(false),
  afterChange: _vueTypes.default.any.def(null),
  arrows: _vueTypes.default.bool.def(true),
  autoplay: _vueTypes.default.bool.def(false),
  autoplaySpeed: _vueTypes.default.number.def(3000),
  beforeChange: _vueTypes.default.any.def(null),
  centerMode: _vueTypes.default.bool.def(false),
  centerPadding: _vueTypes.default.string.def('50px'),
  cssEase: _vueTypes.default.string.def('ease'),
  dots: _vueTypes.default.bool.def(false),
  dotsClass: _vueTypes.default.string.def('slick-dots'),
  draggable: _vueTypes.default.bool.def(true),
  unslick: _vueTypes.default.bool.def(false),
  easing: _vueTypes.default.string.def('linear'),
  edgeFriction: _vueTypes.default.number.def(0.35),
  fade: _vueTypes.default.bool.def(false),
  focusOnSelect: _vueTypes.default.bool.def(false),
  infinite: _vueTypes.default.bool.def(true),
  initialSlide: _vueTypes.default.number.def(0),
  lazyLoad: _vueTypes.default.any.def(null),
  verticalSwiping: _vueTypes.default.bool.def(false),
  asNavFor: _vueTypes.default.any.def(null),
  // 圆点hover是否暂停
  pauseOnDotsHover: _vueTypes.default.bool.def(false),
  // focus是否暂停
  pauseOnFocus: _vueTypes.default.bool.def(false),
  // hover是否暂停
  pauseOnHover: _vueTypes.default.bool.def(true),
  responsive: _vueTypes.default.array,
  rows: _vueTypes.default.number.def(1),
  rtl: _vueTypes.default.bool.def(false),
  slide: _vueTypes.default.string.def('div'),
  slidesPerRow: _vueTypes.default.number.def(1),
  slidesToScroll: _vueTypes.default.number.def(1),
  slidesToShow: _vueTypes.default.number.def(1),
  speed: _vueTypes.default.number.def(500),
  swipe: _vueTypes.default.bool.def(true),
  swipeEvent: _vueTypes.default.any.def(null),
  swipeToSlide: _vueTypes.default.bool.def(false),
  touchMove: _vueTypes.default.bool.def(true),
  touchThreshold: _vueTypes.default.number.def(5),
  useCSS: _vueTypes.default.bool.def(true),
  useTransform: _vueTypes.default.bool.def(true),
  variableWidth: _vueTypes.default.bool.def(false),
  vertical: _vueTypes.default.bool.def(false),
  waitForAnimate: _vueTypes.default.bool.def(true),
  children: _vueTypes.default.array,
  __propsSymbol__: _vueTypes.default.any
};
var _default = defaultProps;
exports.default = _default;